--[[
Specialization for the automatic bale loading of the fliegl DPW 180.

Source: UBT Script

Author: Ifko[nator]
Date: 15.06.2015
Version: 1.1

History: V 1.0 @ 13.06.2015 - intial release
		 V 1.1 @ 15.06.2015 - hot fix - move ALL text's to the helpbox

Website: http://www.modding-welt.com/index.php/BoardList
]]

flieglDPW180 = {};

function flieglDPW180.prerequisitesPresent(specializations)
    return true;
end;

function flieglDPW180:load(xmlFile)
	self.trailerIsEmpty = true;
	
	self.autoLoad = false;
	self.autoLoadText = {g_i18n:getText("AUTOLOAD_MANUAL"), g_i18n:getText("AUTOLOAD_AUTOMATIC")};
	
	self.loadingIsActive = false;
	self.showHelp = false;
	
	self.warningText = {g_i18n:getText("TO_UNLOAD_STOP_AUTOLOAD"), g_i18n:getText("TO_CHANGE_UNLOAD_SIDE_STOP_AUTOLOAD"), g_i18n:getText("TO_CHANGE_BALETYPE_UNLOAD"), g_i18n:getText("TO_CHANGE_LOADINGTYPE_STOP_AUTOUNLOAD")}
	self.showWarning = false;
	self.warning1 = false;
	self.warning2 = false;
	self.warning3 = false;
	self.warning4 = false;
	
	self.unloadLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherParts.unload#leftIndex"));
	self.unloadRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherParts.unload#rightIndex"));
	self.unloadBack = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherParts.unload#backIndex"));
	
	self.nearestDistance = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.attacherParts#nearestDistance"), 10);
	
	self.ulMode = 1;
	self.ulRef = {
		{g_i18n:getText("UNLOAD_LEFT"), false, self.unloadLeft},
		{g_i18n:getText("UNLOAD_BACK"), false, self.unloadBack},
		{g_i18n:getText("UNLOAD_RIGHT"), false, self.unloadRight},
		{g_i18n:getText("UNLOAD_TRAILER"), false, 0}
	};	
	
	self.updateCounter = 1;
	
	self.typeOnTrailer = 1;
	
	self.numAttacherParts = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.attacherParts#count"), 0);
	self.numAttachers = {};
	self.attacher = {};
	self.attacherLevel = {};
	self.choosenBaleType = {};
	
	for i = 1, self.numAttacherParts do
		self.numAttachers[i] = Utils.getNoNil(getXMLInt(xmlFile, string.format("vehicle.attacherParts.attachers" .. "%d" .. "#count", i)), 0);
		self.choosenBaleType[i] = {g_i18n:getText(Utils.getNoNil(getXMLString(xmlFile, string.format("vehicle.attacherParts.attachers" .. "%d" .. "#type", i))), "nil"), i};
		self.attacher[i] = {};
		self.attacherLevel[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, string.format("vehicle.attacherParts.attachers" .. "%d" .. "#index", i)));
		for j = 1,self.numAttachers[i] do
			self.attacher[i][j] = {};
			local partName = string.format("vehicle.attacherParts.attachers" .. "%d" .. ".objectAttacher" .. "%d", i, j);
			self.attacher[i][j].object = Utils.indexToObject(self.components, getXMLString(xmlFile, partName .. "#index"));
			self.attacher[i][j].attachedObject = nil;
			self.attacher[i][j].objectInRange = nil;
		end;
	end;
	
	self.fillLevel = 0;
    self.fillLevelMax = self.numAttachers[self.typeOnTrailer];
	
	self.emptyMass = getMass(self.rootNode);
	
	self.spanngurt = {};
	
	self.spanngurt.quaderballen = {};
	self.spanngurt.quaderballen.ballen1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen1#index"));
	self.spanngurt.quaderballen.ballen2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen2#index"));
	self.spanngurt.quaderballen.ballen3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen3#index"));
	self.spanngurt.quaderballen.ballen4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen4#index"));
	self.spanngurt.quaderballen.ballen5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen5#index"));
	self.spanngurt.quaderballen.ballen6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen6#index"));
	self.spanngurt.quaderballen.ballen7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen7#index"));
	self.spanngurt.quaderballen.ballen8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen8#index"));
	self.spanngurt.quaderballen.ballen9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen9#index"));
	self.spanngurt.quaderballen.ballen10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen10#index"));
	self.spanngurt.quaderballen.ballen11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen11#index"));
	self.spanngurt.quaderballen.ballen12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen12#index"));
	self.spanngurt.quaderballen.ballen13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen13#index"));
	self.spanngurt.quaderballen.ballen14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen14#index"));
	self.spanngurt.quaderballen.ballen15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen15#index"));
	self.spanngurt.quaderballen.ballen16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen16#index"));
	self.spanngurt.quaderballen.ballen17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen17#index"));
	self.spanngurt.quaderballen.ballen18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen18#index"));
	self.spanngurt.quaderballen.ballen19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen19#index"));
	self.spanngurt.quaderballen.ballen20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen20#index"));
	self.spanngurt.quaderballen.ballen21 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen21#index"));
	self.spanngurt.quaderballen.ballen22 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen22#index"));
	self.spanngurt.quaderballen.ballen23 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen23#index"));
	self.spanngurt.quaderballen.ballen24 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteQuaderballen.ballen24#index"));
	
	self.spanngurt.rundballen = {};
	self.spanngurt.rundballen.ballen1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen1#index"));
	self.spanngurt.rundballen.ballen2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen2#index"));
	self.spanngurt.rundballen.ballen3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen3#index"));
	self.spanngurt.rundballen.ballen4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen4#index"));
	self.spanngurt.rundballen.ballen5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen5#index"));
	self.spanngurt.rundballen.ballen6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen6#index"));
	self.spanngurt.rundballen.ballen7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen7#index"));
	self.spanngurt.rundballen.ballen8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen8#index"));
	self.spanngurt.rundballen.ballen9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen9#index"));
	self.spanngurt.rundballen.ballen10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen10#index"));
	self.spanngurt.rundballen.ballen11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen11#index"));
	self.spanngurt.rundballen.ballen12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen12#index"));
	self.spanngurt.rundballen.ballen13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen13#index"));
	self.spanngurt.rundballen.ballen14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen14#index"));
	self.spanngurt.rundballen.ballen15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen15#index"));
	self.spanngurt.rundballen.ballen16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen16#index"));
	self.spanngurt.rundballen.ballen17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen17#index"));
	self.spanngurt.rundballen.ballen18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen18#index"));
	self.spanngurt.rundballen.ballen19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen19#index"));
	self.spanngurt.rundballen.ballen20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen20#index"));
	self.spanngurt.rundballen.ballen21 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen21#index"));
	self.spanngurt.rundballen.ballen22 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen22#index"));
	self.spanngurt.rundballen.ballen23 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen23#index"));
	self.spanngurt.rundballen.ballen24 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen24#index"));
	self.spanngurt.rundballen.ballen25 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen25#index"));
	self.spanngurt.rundballen.ballen26 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen26#index"));
	self.spanngurt.rundballen.ballen27 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen27#index"));
	self.spanngurt.rundballen.ballen28 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen28#index"));
	self.spanngurt.rundballen.ballen29 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen29#index"));
	self.spanngurt.rundballen.ballen30 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteRundballen.ballen30#index"));
	
	self.spanngurt.wollpaletten = {};
	self.spanngurt.wollpaletten.palette1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette1#index"));
	self.spanngurt.wollpaletten.palette2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette2#index"));
	self.spanngurt.wollpaletten.palette3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette3#index"));
	self.spanngurt.wollpaletten.palette4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette4#index"));
	self.spanngurt.wollpaletten.palette5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette5#index"));
	self.spanngurt.wollpaletten.palette6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette6#index"));
	self.spanngurt.wollpaletten.palette7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette7#index"));
	self.spanngurt.wollpaletten.palette8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette8#index"));
	self.spanngurt.wollpaletten.palette9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette9#index"));
	self.spanngurt.wollpaletten.palette10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette10#index"));
	self.spanngurt.wollpaletten.palette11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette11#index"));
	self.spanngurt.wollpaletten.palette12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteWollpaletten.palette12#index"));
	
	self.spanngurt.baumsetzlingpaletten = {};
	self.spanngurt.baumsetzlingpaletten.palette1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette1#index"));
	self.spanngurt.baumsetzlingpaletten.palette2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette2#index"));
	self.spanngurt.baumsetzlingpaletten.palette3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette3#index"));
	self.spanngurt.baumsetzlingpaletten.palette4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette4#index"));
	self.spanngurt.baumsetzlingpaletten.palette5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette5#index"));
	self.spanngurt.baumsetzlingpaletten.palette6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette6#index"));
	self.spanngurt.baumsetzlingpaletten.palette7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette7#index"));
	self.spanngurt.baumsetzlingpaletten.palette8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette8#index"));
	self.spanngurt.baumsetzlingpaletten.palette9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette9#index"));
	self.spanngurt.baumsetzlingpaletten.palette10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette10#index"));
	self.spanngurt.baumsetzlingpaletten.palette11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette11#index"));
	self.spanngurt.baumsetzlingpaletten.palette12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteBaumsetzlingpaletten.palette12#index"));
	
	self.spanngurt.holzpaletten = {};
	self.spanngurt.holzpaletten.palette1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteHolzpaletten.palette1#index"));
	self.spanngurt.holzpaletten.palette2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteHolzpaletten.palette2#index"));
	self.spanngurt.holzpaletten.palette3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteHolzpaletten.palette3#index"));
	self.spanngurt.holzpaletten.palette4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteHolzpaletten.palette4#index"));
	self.spanngurt.holzpaletten.palette5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteHolzpaletten.palette5#index"));
	self.spanngurt.holzpaletten.palette6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteHolzpaletten.palette6#index"));
	self.spanngurt.holzpaletten.palette7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteHolzpaletten.palette7#index"));
	self.spanngurt.holzpaletten.palette8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteHolzpaletten.palette8#index"));
	
	self.spanngurt.kartoffelpaletten = {};
	self.spanngurt.kartoffelpaletten.palette1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette1#index"));
	self.spanngurt.kartoffelpaletten.palette2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette2#index"));
	self.spanngurt.kartoffelpaletten.palette3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette3#index"));
	self.spanngurt.kartoffelpaletten.palette4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette4#index"));
	self.spanngurt.kartoffelpaletten.palette5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette5#index"));
	self.spanngurt.kartoffelpaletten.palette6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette6#index"));
	self.spanngurt.kartoffelpaletten.palette7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette7#index"));
	self.spanngurt.kartoffelpaletten.palette8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette8#index"));
	self.spanngurt.kartoffelpaletten.palette9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette9#index"));
	self.spanngurt.kartoffelpaletten.palette10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette10#index"));
	self.spanngurt.kartoffelpaletten.palette11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette11#index"));
	self.spanngurt.kartoffelpaletten.palette12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spanngurte.spanngurteKartoffelpaletten.palette12#index"));
end;

function flieglDPW180:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then
		local typeOnTrailer = Utils.getNoNil(getXMLInt(xmlFile, key .. "#typeOnTrailer"), self.typeOnTrailer);
		local fillLevel = Utils.getNoNil(getXMLInt(xmlFile, key .. "#fillLevel"), self.fillLevel);
		local ulMode = Utils.getNoNil(getXMLInt(xmlFile, key .. "#ulMode"), self.ulMode);
		local autoLoad = Utils.getNoNil(getXMLBool(xmlFile, key.. "#autoLoad"), self.autoLoad);
		local showHelp = Utils.getNoNil(getXMLBool(xmlFile, key .. "#showHelp"), self.showHelp);
	
		self.typeOnTrailer = typeOnTrailer;
		self.fillLevelMax = self.numAttachers[self.typeOnTrailer];
		self.fillLevel = fillLevel;
		self.ulMode = ulMode;
		self.autoLoad = autoLoad;
		self.showHelp = showHelp;
	end; 

    return BaseMission.VEHICLE_LOAD_OK;
end;

function flieglDPW180:getSaveAttributesAndNodes(nodeIdent)
	self.backMode = self.ulRef[self.ulMode][1]
	
	if not self.trailerIsEmpty then
		self.ulRef[self.ulMode][1] = g_i18n:getText("UNLOAD_TRAILER");
		for i = 1, self.fillLevel do
			if self.attacher[self.typeOnTrailer][i].attachedObject ~= nil then
				flieglDPW180:ObjectDetachFlieglDPW180(self,i);
			end;
		end;
		self.fillLevel = 0;
	end;
	self.ulRef[self.ulMode][1] = self.backMode
	
	if self.loadingIsActive then
		self.loadingIsActive = false;
	end;

	
	local attributes = 
		'fillLevel="'.. tostring(self.fillLevel) .. 
		'"typeOnTrailer="'.. tostring(self.typeOnTrailer) ..
		'" ulMode="'.. tostring(self.ulMode) ..
		'" autoLoad="'.. tostring(self.autoLoad) ..
		'" showHelp="'.. tostring(self.showHelp) ..
	'"';
	
	return attributes, nil;
end;


function flieglDPW180:delete()
	self.ulRef[self.ulMode][1] = g_i18n:getText("UNLOAD_TRAILER");
	if not self.trailerIsEmpty then
		for i = 1, self.fillLevel do
			if self.attacher[self.typeOnTrailer][i].attachedObject ~= nil then
				flieglDPW180:ObjectDetachFlieglDPW180(self,i);
			end;
		end;
		self.fillLevel = 0;
	end;
	
	if self.loadingIsActive then
		self.loadingIsActive = false;
	end;
end;

function flieglDPW180:mouseEvent(posX, posY, isDown, isUp, button)
end;

function flieglDPW180:keyEvent(unicode, sym, modifier, isDown)
end;

function flieglDPW180:update(dt)
	self.showWarning = false;
	self.warning1 = false;
	self.warning2 = false;
	self.warning3 = false;
	self.warning4 = false;
	
	if self:getIsActiveForInput() then
		-- bale loading
		if InputBinding.hasEvent(InputBinding.FLIEGL_DPW180_LOAD) and not self.autoLoad then
			for i = 1, self.numAttachers[self.typeOnTrailer] do
				if self.attacher[self.typeOnTrailer][i].attachedObject == nil then
					local nearest = flieglDPW180:ObjectInRangeFlieglDPW180(self, i);
					if nearest ~= nil then
						self.attacher[self.typeOnTrailer][i].objectInRange = nearest;
						flieglDPW180:ObjectAttachFlieglDPW180(self, i);
					else
						break;
					end;
				end;
			end;
		elseif InputBinding.hasEvent(InputBinding.FLIEGL_DPW180_LOAD) and self.autoLoad then
			self.loadingIsActive = not self.loadingIsActive;
		end;
		-- bale unloading
		if InputBinding.hasEvent(InputBinding.FLIEGL_DPW180_UNLOAD) then
			if not self.loadingIsActive then
				for k = 1, self.numAttachers[self.typeOnTrailer] do
					if self.attacher[self.typeOnTrailer][k].attachedObject ~= nil then
						flieglDPW180:ObjectDetachFlieglDPW180(self, k);
						self.fillLevel = self.fillLevel - 1;
					end;
				end;
				self.fillLevel = 0;
			else
				self.showWarning = true;
				self.warning1 = true;
			end;
		end;
		-- toggle unloading side (left, back, right, trailer)
		if InputBinding.hasEvent(InputBinding.FLIEGL_DPW180_TOGGLE_UNLOAD_SIDE) then
			if not self.loadingIsActive then
				if self.ulMode == 4 then
					self.ulMode = 0;
				end;
				self.ulMode = self.ulMode + 1;
			else
				self.showWarning = true;
				self.warning2 = true;
			end;
		end;
		-- toggle bale type (round, normal_samll, normal_big, woolpallet, seedlingpallet)
		if InputBinding.hasEvent(InputBinding.FLIEGL_DPW180_TOGGLE_BALE_TYPE) then
			if self.trailerIsEmpty then
				if self.typeOnTrailer == #(self.numAttachers) then
					self.typeOnTrailer = 0;
				end;
				self.typeOnTrailer = self.typeOnTrailer + 1;
				self.fillLevelMax = self.numAttachers[self.typeOnTrailer];
			else
				self.showWarning = true;
				self.warning3 = true;
			end;
		end;
		-- toggle loading type (automatic, manual)
		if InputBinding.hasEvent(InputBinding.FLIEGL_DPW180_TOGGLE_LOADING_TYPE) then
			if self.autoLoad and not self.loadingIsActive then
				self.autoLoad = false;
			else
				self.autoLoad = true;
			end;
			
			if self.loadingIsActive then
				self.showWarning = true;
				self.warning4 = true;
			end;
		end;
		--toggle displaying HUD
		if InputBinding.hasEvent(InputBinding.FLIEGL_DPW180_TOGGLE_HUD) then
			self.showHelp = not self.showHelp;
		end;
	end;
end;

function flieglDPW180:updateTick(dt)
	if self.fillLevel == 0 then
		self.trailerIsEmpty = true;
	else
		self.trailerIsEmpty = false;
	end;
	
	if self.fillLevel == self.fillLevelMax then
		self.loadingIsActive = false;
		
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("SQUAREBALE") then
			setVisibility(self.spanngurt.quaderballen.ballen23, false);
			setVisibility(self.spanngurt.quaderballen.ballen24, true);
		else
			setVisibility(self.spanngurt.quaderballen.ballen24, false);
		end;
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("ROUNDBALE") then
			setVisibility(self.spanngurt.rundballen.ballen29, false);
			setVisibility(self.spanngurt.rundballen.ballen30, true);
		else
			setVisibility(self.spanngurt.rundballen.ballen30, false);
		end;
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("WOOLPALLET") then
			setVisibility(self.spanngurt.wollpaletten.palette11, false);
			setVisibility(self.spanngurt.wollpaletten.palette12, true);
		else
			setVisibility(self.spanngurt.wollpaletten.palette12, false);
		end;
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("SEEDLINGPALLET") then
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette11, false);
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette12, true);
		else
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette12, false);
		end;
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("BOARDPALLET") then
			setVisibility(self.spanngurt.holzpaletten.palette7, false);
			setVisibility(self.spanngurt.holzpaletten.palette8, true);
		else
			setVisibility(self.spanngurt.holzpaletten.palette8, false);
		end;
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("WASHEDPOTATOPALLET") then
			setVisibility(self.spanngurt.kartoffelpaletten.palette11, false);
			setVisibility(self.spanngurt.kartoffelpaletten.palette12, true);
		else
			setVisibility(self.spanngurt.kartoffelpaletten.palette12, false);
		end;
	else
		setVisibility(self.spanngurt.quaderballen.ballen24, false);
		setVisibility(self.spanngurt.rundballen.ballen30, false);
		setVisibility(self.spanngurt.wollpaletten.palette12, false);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette12, false);
		setVisibility(self.spanngurt.holzpaletten.palette8, false);
		setVisibility(self.spanngurt.kartoffelpaletten.palette12, false);
		
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("SQUAREBALE") then
			if self.fillLevel == 1 then
				setVisibility(self.spanngurt.quaderballen.ballen1, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen1, false);
			end;
			if self.fillLevel == 2 then
				setVisibility(self.spanngurt.quaderballen.ballen2, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen2, false);
			end;
			if self.fillLevel == 3 then
				setVisibility(self.spanngurt.quaderballen.ballen3, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen3, false);
			end;
			if self.fillLevel == 4 then
				setVisibility(self.spanngurt.quaderballen.ballen4, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen4, false);
			end;
			if self.fillLevel == 5 then
				setVisibility(self.spanngurt.quaderballen.ballen5, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen5, false);
			end;
			if self.fillLevel == 6 then
				setVisibility(self.spanngurt.quaderballen.ballen6, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen6, false);
			end;
			if self.fillLevel == 7 then
				setVisibility(self.spanngurt.quaderballen.ballen7, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen7, false);
			end;
			if self.fillLevel == 8 then
				setVisibility(self.spanngurt.quaderballen.ballen8, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen8, false);
			end;
			if self.fillLevel == 9 then
				setVisibility(self.spanngurt.quaderballen.ballen9, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen9, false);
			end;
			if self.fillLevel == 10 then
				setVisibility(self.spanngurt.quaderballen.ballen10, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen10, false);
			end;
			if self.fillLevel == 11 then
				setVisibility(self.spanngurt.quaderballen.ballen11, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen11, false);
			end;
			if self.fillLevel == 12 then
				setVisibility(self.spanngurt.quaderballen.ballen12, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen12, false);
			end;
			if self.fillLevel == 13 then
				setVisibility(self.spanngurt.quaderballen.ballen13, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen13, false);
			end;
			if self.fillLevel == 14 then
				setVisibility(self.spanngurt.quaderballen.ballen14, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen14, false);
			end;
			if self.fillLevel == 15 then
				setVisibility(self.spanngurt.quaderballen.ballen15, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen15, false);
			end;
			if self.fillLevel == 16 then
				setVisibility(self.spanngurt.quaderballen.ballen16, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen16, false);
			end;
			if self.fillLevel == 17 then
				setVisibility(self.spanngurt.quaderballen.ballen17, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen17, false);
			end;
			if self.fillLevel == 18 then
				setVisibility(self.spanngurt.quaderballen.ballen18, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen18, false);
			end;
			if self.fillLevel == 19 then
				setVisibility(self.spanngurt.quaderballen.ballen19, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen19, false);
			end;
			if self.fillLevel == 20 then
				setVisibility(self.spanngurt.quaderballen.ballen20, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen20, false);
			end;
			if self.fillLevel == 21 then
				setVisibility(self.spanngurt.quaderballen.ballen21, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen21, false);
			end;
			if self.fillLevel == 22 then
				setVisibility(self.spanngurt.quaderballen.ballen22, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen22, false);
			end;
			if self.fillLevel == 23 then
				setVisibility(self.spanngurt.quaderballen.ballen23, true);
			else
				setVisibility(self.spanngurt.quaderballen.ballen23, false);
			end;
		else
			setVisibility(self.spanngurt.quaderballen.ballen1, false);
			setVisibility(self.spanngurt.quaderballen.ballen2, false);
			setVisibility(self.spanngurt.quaderballen.ballen3, false);
			setVisibility(self.spanngurt.quaderballen.ballen4, false);
			setVisibility(self.spanngurt.quaderballen.ballen5, false);
			setVisibility(self.spanngurt.quaderballen.ballen6, false);
			setVisibility(self.spanngurt.quaderballen.ballen7, false);
			setVisibility(self.spanngurt.quaderballen.ballen8, false);
			setVisibility(self.spanngurt.quaderballen.ballen9, false);
			setVisibility(self.spanngurt.quaderballen.ballen10, false);
			setVisibility(self.spanngurt.quaderballen.ballen11, false);
			setVisibility(self.spanngurt.quaderballen.ballen12, false);
			setVisibility(self.spanngurt.quaderballen.ballen13, false);
			setVisibility(self.spanngurt.quaderballen.ballen14, false);
			setVisibility(self.spanngurt.quaderballen.ballen15, false);
			setVisibility(self.spanngurt.quaderballen.ballen16, false);
			setVisibility(self.spanngurt.quaderballen.ballen17, false);
			setVisibility(self.spanngurt.quaderballen.ballen18, false);
			setVisibility(self.spanngurt.quaderballen.ballen19, false);
			setVisibility(self.spanngurt.quaderballen.ballen20, false);
			setVisibility(self.spanngurt.quaderballen.ballen21, false);
			setVisibility(self.spanngurt.quaderballen.ballen22, false);
			setVisibility(self.spanngurt.quaderballen.ballen23, false);
		end;
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("ROUNDBALE") then
			if self.fillLevel == 1 then
				setVisibility(self.spanngurt.rundballen.ballen1, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen1, false);
			end;
			if self.fillLevel == 2 then
				setVisibility(self.spanngurt.rundballen.ballen2, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen2, false);
			end;
			if self.fillLevel == 3 then
				setVisibility(self.spanngurt.rundballen.ballen3, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen3, false);
			end;
			if self.fillLevel == 4 then
				setVisibility(self.spanngurt.rundballen.ballen4, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen4, false);
			end;
			if self.fillLevel == 5 then
				setVisibility(self.spanngurt.rundballen.ballen5, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen5, false);
			end;
			if self.fillLevel == 6 then
				setVisibility(self.spanngurt.rundballen.ballen6, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen6, false);
			end;
			if self.fillLevel == 7 then
				setVisibility(self.spanngurt.rundballen.ballen7, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen7, false);
			end;
			if self.fillLevel == 8 then
				setVisibility(self.spanngurt.rundballen.ballen8, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen8, false);
			end;
			if self.fillLevel == 9 then
				setVisibility(self.spanngurt.rundballen.ballen9, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen9, false);
			end;
			if self.fillLevel == 10 then
				setVisibility(self.spanngurt.rundballen.ballen10, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen10, false);
			end;
			if self.fillLevel == 11 then
				setVisibility(self.spanngurt.rundballen.ballen11, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen11, false);
			end;
			if self.fillLevel == 12 then
				setVisibility(self.spanngurt.rundballen.ballen12, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen12, false);
			end;
			if self.fillLevel == 13 then
				setVisibility(self.spanngurt.rundballen.ballen13, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen13, false);
			end;
			if self.fillLevel == 14 then
				setVisibility(self.spanngurt.rundballen.ballen14, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen14, false);
			end;
			if self.fillLevel == 15 then
				setVisibility(self.spanngurt.rundballen.ballen15, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen15, false);
			end;
			if self.fillLevel == 16 then
				setVisibility(self.spanngurt.rundballen.ballen16, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen16, false);
			end;
			if self.fillLevel == 17 then
				setVisibility(self.spanngurt.rundballen.ballen17, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen17, false);
			end;
			if self.fillLevel == 18 then
				setVisibility(self.spanngurt.rundballen.ballen18, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen18, false);
			end;
			if self.fillLevel == 19 then
				setVisibility(self.spanngurt.rundballen.ballen19, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen19, false);
			end;
			if self.fillLevel == 20 then
				setVisibility(self.spanngurt.rundballen.ballen20, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen20, false);
			end;
			if self.fillLevel == 21 then
				setVisibility(self.spanngurt.rundballen.ballen21, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen21, false);
			end;
			if self.fillLevel == 22 then
				setVisibility(self.spanngurt.rundballen.ballen22, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen22, false);
			end;
			if self.fillLevel == 23 then
				setVisibility(self.spanngurt.rundballen.ballen23, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen23, false);
			end;
			if self.fillLevel == 24 then
				setVisibility(self.spanngurt.rundballen.ballen24, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen24, false);
			end;
			if self.fillLevel == 25 then
				setVisibility(self.spanngurt.rundballen.ballen25, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen25, false);
			end;
			if self.fillLevel == 26 then
				setVisibility(self.spanngurt.rundballen.ballen26, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen26, false);
			end;
			if self.fillLevel == 27 then
				setVisibility(self.spanngurt.rundballen.ballen27, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen27, false);
			end;
			if self.fillLevel == 28 then
				setVisibility(self.spanngurt.rundballen.ballen28, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen28, false);
			end;
			if self.fillLevel == 29 then
				setVisibility(self.spanngurt.rundballen.ballen29, true);
			else
				setVisibility(self.spanngurt.rundballen.ballen29, false);
			end;
		else
			setVisibility(self.spanngurt.rundballen.ballen1, false);
			setVisibility(self.spanngurt.rundballen.ballen2, false);
			setVisibility(self.spanngurt.rundballen.ballen3, false);
			setVisibility(self.spanngurt.rundballen.ballen4, false);
			setVisibility(self.spanngurt.rundballen.ballen5, false);
			setVisibility(self.spanngurt.rundballen.ballen6, false);
			setVisibility(self.spanngurt.rundballen.ballen7, false);
			setVisibility(self.spanngurt.rundballen.ballen8, false);
			setVisibility(self.spanngurt.rundballen.ballen9, false);
			setVisibility(self.spanngurt.rundballen.ballen10, false);
			setVisibility(self.spanngurt.rundballen.ballen11, false);
			setVisibility(self.spanngurt.rundballen.ballen12, false);
			setVisibility(self.spanngurt.rundballen.ballen13, false);
			setVisibility(self.spanngurt.rundballen.ballen14, false);
			setVisibility(self.spanngurt.rundballen.ballen15, false);
			setVisibility(self.spanngurt.rundballen.ballen16, false);
			setVisibility(self.spanngurt.rundballen.ballen17, false);
			setVisibility(self.spanngurt.rundballen.ballen18, false);
			setVisibility(self.spanngurt.rundballen.ballen19, false);
			setVisibility(self.spanngurt.rundballen.ballen20, false);
			setVisibility(self.spanngurt.rundballen.ballen21, false);
			setVisibility(self.spanngurt.rundballen.ballen22, false);
			setVisibility(self.spanngurt.rundballen.ballen23, false);
			setVisibility(self.spanngurt.rundballen.ballen24, false);
			setVisibility(self.spanngurt.rundballen.ballen25, false);
			setVisibility(self.spanngurt.rundballen.ballen26, false);
			setVisibility(self.spanngurt.rundballen.ballen27, false);
			setVisibility(self.spanngurt.rundballen.ballen28, false);
			setVisibility(self.spanngurt.rundballen.ballen29, false);
		end;
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("WOOLPALLET") then
			if self.fillLevel == 1 then
				setVisibility(self.spanngurt.wollpaletten.palette1, true);
			else
				setVisibility(self.spanngurt.wollpaletten.palette1, false);
			end;
			if self.fillLevel == 2 then
				setVisibility(self.spanngurt.wollpaletten.palette2, true);
			else
				setVisibility(self.spanngurt.wollpaletten.palette2, false);
			end;
			if self.fillLevel == 3 then
				setVisibility(self.spanngurt.wollpaletten.palette3, true);
			else
				setVisibility(self.spanngurt.wollpaletten.palette3, false);
			end;
			if self.fillLevel == 4 then
				setVisibility(self.spanngurt.wollpaletten.palette4, true);
			else
				setVisibility(self.spanngurt.wollpaletten.palette4, false);
			end;
			if self.fillLevel == 5 then
				setVisibility(self.spanngurt.wollpaletten.palette5, true);
			else
				setVisibility(self.spanngurt.wollpaletten.palette5, false);
			end;
			if self.fillLevel == 6 then
				setVisibility(self.spanngurt.wollpaletten.palette6, true);
			else
				setVisibility(self.spanngurt.wollpaletten.palette6, false);
			end;
			if self.fillLevel == 7 then
				setVisibility(self.spanngurt.wollpaletten.palette7, true);
			else
				setVisibility(self.spanngurt.wollpaletten.palette7, false);
			end;
			if self.fillLevel == 8 then
				setVisibility(self.spanngurt.wollpaletten.palette8, true);
			else
				setVisibility(self.spanngurt.wollpaletten.palette8, false);
			end;
			if self.fillLevel == 9 then
				setVisibility(self.spanngurt.wollpaletten.palette9, true);
			else
				setVisibility(self.spanngurt.wollpaletten.palette9, false);
			end;
			if self.fillLevel == 10 then
				setVisibility(self.spanngurt.wollpaletten.palette10, true);
			else
				setVisibility(self.spanngurt.wollpaletten.palette10, false);
			end;
			if self.fillLevel == 11 then
				setVisibility(self.spanngurt.wollpaletten.palette11, true);
			else
				setVisibility(self.spanngurt.wollpaletten.palette11, false);
			end;
		else
			setVisibility(self.spanngurt.wollpaletten.palette1, false);
			setVisibility(self.spanngurt.wollpaletten.palette2, false);
			setVisibility(self.spanngurt.wollpaletten.palette3, false);
			setVisibility(self.spanngurt.wollpaletten.palette4, false);
			setVisibility(self.spanngurt.wollpaletten.palette5, false);
			setVisibility(self.spanngurt.wollpaletten.palette6, false);
			setVisibility(self.spanngurt.wollpaletten.palette7, false);
			setVisibility(self.spanngurt.wollpaletten.palette8, false);
			setVisibility(self.spanngurt.wollpaletten.palette9, false);
			setVisibility(self.spanngurt.wollpaletten.palette10, false);
			setVisibility(self.spanngurt.wollpaletten.palette11, false);
		end;
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("SEEDLINGPALLET") then
			if self.fillLevel == 1 then
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette1, true);
			else
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette1, false);
			end;
			if self.fillLevel == 2 then
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette2, true);
			else
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette2, false);
			end;
			if self.fillLevel == 3 then
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette3, true);
			else
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette3, false);
			end;
			if self.fillLevel == 4 then
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette4, true);
			else
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette4, false);
			end;
			if self.fillLevel == 5 then
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette5, true);
			else
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette5, false);
			end;
			if self.fillLevel == 6 then
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette6, true);
			else
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette6, false);
			end;
			if self.fillLevel == 7 then
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette7, true);
			else
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette7, false);
			end;
			if self.fillLevel == 8 then
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette8, true);
			else
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette8, false);
			end;
			if self.fillLevel == 9 then
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette9, true);
			else
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette9, false);
			end;
			if self.fillLevel == 10 then
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette10, true);
			else
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette10, false);
			end;
			if self.fillLevel == 11 then
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette11, true);
			else
				setVisibility(self.spanngurt.baumsetzlingpaletten.palette11, false);
			end;
		else
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette1, false);
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette2, false);
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette3, false);
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette4, false);
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette5, false);
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette6, false);
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette7, false);
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette8, false);
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette9, false);
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette10, false);
			setVisibility(self.spanngurt.baumsetzlingpaletten.palette11, false);
		end;
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("BOARDPALLET") then
			if self.fillLevel == 1 then
				setVisibility(self.spanngurt.holzpaletten.palette1, true);
			else
				setVisibility(self.spanngurt.holzpaletten.palette1, false);
			end;
			if self.fillLevel == 2 then
				setVisibility(self.spanngurt.holzpaletten.palette2, true);
			else
				setVisibility(self.spanngurt.holzpaletten.palette2, false);
			end;
			if self.fillLevel == 3 then
				setVisibility(self.spanngurt.holzpaletten.palette3, true);
			else
				setVisibility(self.spanngurt.holzpaletten.palette3, false);
			end;
			if self.fillLevel == 4 then
				setVisibility(self.spanngurt.holzpaletten.palette4, true);
			else
				setVisibility(self.spanngurt.holzpaletten.palette4, false);
			end;
			if self.fillLevel == 5 then
				setVisibility(self.spanngurt.holzpaletten.palette5, true);
			else
				setVisibility(self.spanngurt.holzpaletten.palette5, false);
			end;
			if self.fillLevel == 6 then
				setVisibility(self.spanngurt.holzpaletten.palette6, true);
			else
				setVisibility(self.spanngurt.holzpaletten.palette6, false);
			end;
			if self.fillLevel == 7 then
				setVisibility(self.spanngurt.holzpaletten.palette7, true);
			else
				setVisibility(self.spanngurt.holzpaletten.palette7, false);
			end;
		else
			setVisibility(self.spanngurt.holzpaletten.palette1, false);
			setVisibility(self.spanngurt.holzpaletten.palette2, false);
			setVisibility(self.spanngurt.holzpaletten.palette3, false);
			setVisibility(self.spanngurt.holzpaletten.palette4, false);
			setVisibility(self.spanngurt.holzpaletten.palette5, false);
			setVisibility(self.spanngurt.holzpaletten.palette6, false);
			setVisibility(self.spanngurt.holzpaletten.palette7, false);
		end;
		if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("WASHEDPOTATOPALLET") then
			if self.fillLevel == 1 then
				setVisibility(self.spanngurt.kartoffelpaletten.palette1, true);
			else
				setVisibility(self.spanngurt.kartoffelpaletten.palette1, false);
			end;
			if self.fillLevel == 2 then
				setVisibility(self.spanngurt.kartoffelpaletten.palette2, true);
			else
				setVisibility(self.spanngurt.kartoffelpaletten.palette2, false);
			end;
			if self.fillLevel == 3 then
				setVisibility(self.spanngurt.kartoffelpaletten.palette3, true);
			else
				setVisibility(self.spanngurt.kartoffelpaletten.palette3, false);
			end;
			if self.fillLevel == 4 then
				setVisibility(self.spanngurt.kartoffelpaletten.palette4, true);
			else
				setVisibility(self.spanngurt.kartoffelpaletten.palette4, false);
			end;
			if self.fillLevel == 5 then
				setVisibility(self.spanngurt.kartoffelpaletten.palette5, true);
			else
				setVisibility(self.spanngurt.kartoffelpaletten.palette5, false);
			end;
			if self.fillLevel == 6 then
				setVisibility(self.spanngurt.kartoffelpaletten.palette6, true);
			else
				setVisibility(self.spanngurt.kartoffelpaletten.palette6, false);
			end;
			if self.fillLevel == 7 then
				setVisibility(self.spanngurt.kartoffelpaletten.palette7, true);
			else
				setVisibility(self.spanngurt.kartoffelpaletten.palette7, false);
			end;
			if self.fillLevel == 8 then
				setVisibility(self.spanngurt.kartoffelpaletten.palette8, true);
			else
				setVisibility(self.spanngurt.kartoffelpaletten.palette8, false);
			end;
			if self.fillLevel == 9 then
				setVisibility(self.spanngurt.kartoffelpaletten.palette9, true);
			else
				setVisibility(self.spanngurt.kartoffelpaletten.palette9, false);
			end;
			if self.fillLevel == 10 then
				setVisibility(self.spanngurt.kartoffelpaletten.palette10, true);
			else
				setVisibility(self.spanngurt.kartoffelpaletten.palette10, false);
			end;
			if self.fillLevel == 11 then
				setVisibility(self.spanngurt.kartoffelpaletten.palette11, true);
			else
				setVisibility(self.spanngurt.kartoffelpaletten.palette11, false);
			end;
		else
			setVisibility(self.spanngurt.kartoffelpaletten.palette1, false);
			setVisibility(self.spanngurt.kartoffelpaletten.palette2, false);
			setVisibility(self.spanngurt.kartoffelpaletten.palette3, false);
			setVisibility(self.spanngurt.kartoffelpaletten.palette4, false);
			setVisibility(self.spanngurt.kartoffelpaletten.palette5, false);
			setVisibility(self.spanngurt.kartoffelpaletten.palette6, false);
			setVisibility(self.spanngurt.kartoffelpaletten.palette7, false);
			setVisibility(self.spanngurt.kartoffelpaletten.palette8, false);
			setVisibility(self.spanngurt.kartoffelpaletten.palette9, false);
			setVisibility(self.spanngurt.kartoffelpaletten.palette10, false);
			setVisibility(self.spanngurt.kartoffelpaletten.palette11, false);
		end;
	end;
	
	-- autoload
	if self.autoLoad and self.loadingIsActive then
		local i = self.fillLevel + 1;
		if self.attacher[self.typeOnTrailer][i].attachedObject == nil then
			local nearest = flieglDPW180:ObjectInRangeFlieglDPW180(self, i);
			if nearest ~= nil then
				self.attacher[self.typeOnTrailer][i].objectInRange = nearest;
				flieglDPW180:ObjectAttachFlieglDPW180(self, i);
			end;
		end;
	end;
end;

function flieglDPW180:draw()
	local autoLoadText = "unknown";
	local warningText = "unknown";
	
	if self.autoLoad then
		autoLoadText = self.autoLoadText[2];
	else
		autoLoadText = self.autoLoadText[1];
	end;
	
	if self.warning1 then
		warningText = self.warningText[1];
	end;
	
	if self.warning2 then
		warningText = self.warningText[2];
	end;
	
	if self.warning3 then
		warningText = self.warningText[3];
	end;
	
	if self.warning4 then
		warningText = self.warningText[4];
	end;
	
	if self.showWarning then
		g_currentMission:showBlinkingWarning(warningText);
	end;
	
	if self.showHelp then
		g_currentMission:addExtraPrintText(string.format(g_i18n:getText("FLIEGL_DPW180_CURRENT_FILL_LEVEL"), self.fillLevel, self.fillLevelMax));
		g_currentMission:addExtraPrintText(string.format(g_i18n:getText("FLIEGL_DPW180_LOADING_TYPE"), autoLoadText));
		g_currentMission:addExtraPrintText(string.format(g_i18n:getText("FLIEGL_DPW180_CHOOSEN_BALETYPE"), self.choosenBaleType[self.typeOnTrailer][1]));
	
		if self.autoLoad then
			if self.loadingIsActive then
				g_currentMission:addHelpButtonText(g_i18n:getText("FLIEGL_DPW180_STOP_AUTOLOAD"), InputBinding.FLIEGL_DPW180_LOAD);
				g_currentMission:addExtraPrintText(g_i18n:getText("FLIEGL_DPW180_STOP_AUTOLOAD_TO_UNLOAD"));
			else
				if self.fillLevel < self.fillLevelMax then
					g_currentMission:addHelpButtonText(g_i18n:getText("FLIEGL_DPW180_START_AUTOLOAD"), InputBinding.FLIEGL_DPW180_LOAD);
					g_currentMission:addHelpButtonText(g_i18n:getText("FLIEGL_DPW180_TOGGLE_LOADING_TYPE"), InputBinding.FLIEGL_DPW180_TOGGLE_LOADING_TYPE);
				end;
			end;
		else
			if self.fillLevel < self.fillLevelMax then
				g_currentMission:addHelpButtonText(g_i18n:getText("FLIEGL_DPW180_LOAD"), InputBinding.FLIEGL_DPW180_LOAD);
				g_currentMission:addHelpButtonText(g_i18n:getText("FLIEGL_DPW180_TOGGLE_LOADING_TYPE"), InputBinding.FLIEGL_DPW180_TOGGLE_LOADING_TYPE);
			end;
		end;
		
		if self.fillLevel > 0 and not self.loadingIsActive then
			g_currentMission:addHelpButtonText(g_i18n:getText("FLIEGL_DPW180_UNLOAD"), InputBinding.FLIEGL_DPW180_UNLOAD);
			g_currentMission:addHelpButtonText(g_i18n:getText("FLIEGL_DPW180_TOGGLE_UNLOAD_SIDE"), InputBinding.FLIEGL_DPW180_TOGGLE_UNLOAD_SIDE);
			g_currentMission:addExtraPrintText(string.format(g_i18n:getText("FLIEGL_DPW180_UNLOAD_MODE"), self.ulRef[self.ulMode][1]));
		end;
		
		if self.fillLevel == 0 then
			g_currentMission:addHelpButtonText(g_i18n:getText("FLIEGL_DPW180_TOGGLE_BALE_TYPE"), InputBinding.FLIEGL_DPW180_TOGGLE_BALE_TYPE);
		end;
		
		g_currentMission:addHelpButtonText(g_i18n:getText("FLIEGL_DPW180_HUD_HIDE"), InputBinding.FLIEGL_DPW180_TOGGLE_HUD);
	else
		g_currentMission:addHelpButtonText(g_i18n:getText("FLIEGL_DPW180_HUD_SHOW"), InputBinding.FLIEGL_DPW180_TOGGLE_HUD);
	end;
end;

function flieglDPW180:ObjectInRangeFlieglDPW180(self, k)
	local nearestObject;
	local itemNode;
	local index;
	local nearestDistance = self.nearestDistance;
	local objectCopy = self.attacher[self.typeOnTrailer][k].object;
	local px, py, pz = getWorldTranslation(objectCopy);
	
	for index, item in pairs(g_currentMission.itemsToSave) do
		itemNode = item.item.nodeId;
		if getParent(item.item.nodeId) == getRootNode() then
			local vx, vy, vz = getWorldTranslation(itemNode);
			local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
			if distance < nearestDistance then
				if self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("SQUAREBALE") then
					if item.item.i3dFilename == "data/maps/models/objects/squarebales/baleStraw240.i3d" 
						or item.item.i3dFilename == "data/maps/models/objects/squarebales/baleHay240.i3d" 
						or getUserAttribute(itemNode, "isSquarebale")
					then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
					end;
				elseif self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("ROUNDBALE") then
					if getUserAttribute(itemNode, "isRoundbale") then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
					end;
				elseif self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("WOOLPALLET") then
					local capacity = item.item.capacity;
					local fillLevel = item.item.fillLevel;
					
					if item.item.i3dFilename == "data/maps/models/objects/pallets/woolPallet.i3d" 
						and fillLevel == capacity 
					then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
					end;
				elseif self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("SEEDLINGPALLET") then
					if item.item.i3dFilename == "data/objects/pallets/treeSaplingPallet.i3d" 
						-- support for mod seedling pallet's
						or getUserAttribute(itemNode, "deleteIfEmpty")
					then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
					end;
				elseif self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("BOARDPALLET") then 
					-- support for marhu's board pallet's
					local fillType = getUserAttribute(itemNode, "fillType");
					local capacity = getUserAttribute(itemNode, "capacity");
					local fillLevel = item.item.fillLevel;
					
					if fillType == "woodChips" and fillLevel == capacity then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
					end;
				elseif self.choosenBaleType[self.typeOnTrailer][1] == g_i18n:getText("WASHEDPOTATOPALLET") then 
					-- support for Farmer_Andy's washed potato pallet's
					local fillType = getUserAttribute(itemNode, "fillType");
					
					if fillType == "washedPotato" then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
					end;
				end;
			end;
		end;
	end;
	
	return nearestObject;
end;

function flieglDPW180:ObjectAttachFlieglDPW180(self,k)
	local x, y, z = getWorldRotation(self.attacher[self.typeOnTrailer][k].objectInRange);
	
	setTranslation(self.attacher[self.typeOnTrailer][k].objectInRange, 0, 0, 0);
	setRotation(self.attacher[self.typeOnTrailer][k].objectInRange, 0, 0, 0);
	removeFromPhysics(self.attacher[self.typeOnTrailer][k].objectInRange);
	link(self.attacher[self.typeOnTrailer][k].object, self.attacher[self.typeOnTrailer][k].objectInRange);
	self.attacher[self.typeOnTrailer][k].attachedObject = self.attacher[self.typeOnTrailer][k].objectInRange;
	self.attacher[self.typeOnTrailer][k].objectInRange = nil;
	self.fillLevel = self.fillLevel + 1;
end;

function flieglDPW180:ObjectDetachFlieglDPW180(self,k)
	if self.attacher[self.typeOnTrailer][k].attachedObject ~= nil then
		if self.ulRef[self.ulMode][1] == g_i18n:getText("UNLOAD_TRAILER") then
			local x, y, z = getWorldTranslation(self.attacher[self.typeOnTrailer][k].attachedObject);
			local rx, ry, rz = getWorldRotation(self.attacher[self.typeOnTrailer][k].attachedObject);
			local root = getRootNode();
			
			setTranslation(self.attacher[self.typeOnTrailer][k].attachedObject, x, y, z);
			setRotation(self.attacher[self.typeOnTrailer][k].attachedObject, rx, ry, rz);
			addToPhysics(self.attacher[self.typeOnTrailer][k].attachedObject);
			link(root, self.attacher[self.typeOnTrailer][k].attachedObject);
			self.attacher[self.typeOnTrailer][k].attachedObject = nil;
		else
			local x, y, z = getWorldTranslation(self.attacher[self.typeOnTrailer][k].attachedObject);
			local rx, ry, rz = getWorldRotation(self.attacher[self.typeOnTrailer][k].attachedObject);
			local nx, ny, nz = getWorldTranslation(self.attacherLevel[self.typeOnTrailer]);
			local tx, ty, tz = getWorldTranslation(self.ulRef[self.ulMode][3]);
			local x = x + (tx - nx);
			local y = y + (ty - ny);
			local z = z + (tz - nz);
			local tH = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
			local relHeight = ny - tH;
			local root = getRootNode();
			
			setTranslation(self.attacher[self.typeOnTrailer][k].attachedObject, x, (y - relHeight), z);
			setRotation(self.attacher[self.typeOnTrailer][k].attachedObject, rx, ry, rz);
			addToPhysics(self.attacher[self.typeOnTrailer][k].attachedObject);
			link(root, self.attacher[self.typeOnTrailer][k].attachedObject);
			self.attacher[self.typeOnTrailer][k].attachedObject = nil;
		end;
	end;
end;

function flieglDPW180:onDetach()
	self.loadingIsActive = false;
end;

function flieglDPW180:onLeave()
	self.loadingIsActive = false;
end;